<?php

/**
 * co_fase_ep_prueba actions.
 *
 * @package    contratacion
 * @subpackage co_fase_ep_prueba
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_fase_epActions extends sfActions
{
 /**
  * Executes list action
  *
  * @param sfRequest $request A request object
  */
  public function executeList(sfWebRequest $request)
  {
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        
        $consulta="";
        
        try {
            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }
            if(isset($request['aplica_formulario'])){
                $consulta="and tab0.aplica_formulario=1";
            }
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from CO_FASE_EP
EOD;
            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];
            //validar si hay registros
            if ($total_record_count > 0) {
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
select tab0.id_fase_ep, tab0.codigo, 'HOJA '||rownum AS DESCRIPCION, tab0.orden,tab0.aplica_formulario from CO_FASE_EP tab0  
where 1 = 1
$consulta
order by ID_FASE_EP
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);
                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('CO_FASE_EP_PRUEBA_OBJ');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowStart + count($records);
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[INF_CO_FASE_EP] Consulta exitosa.");
            }
            else {

                $mensaje = "[INF_CO_FASE_EP] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error = "[INF_CO_FASE_EP] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeAdd(sfWebRequest $request)
  {
    $this->logMessage("[INF_CO_FASE_EP] Entra por agregar objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $codigo=$request['codigo'];
            $descripcion=$request['descripcion'];
            $orden=$request['orden'];
            $aplica_formulario=$request['aplica_formulario'];
            if($aplica_formulario=="true"){
                $aplica_formulario=1;
            }
            else{
                $aplica_formulario=0;
            }
            $sql = <<<EOD
INSERT INTO CO_FASE_EP (ID_FASE_EP, CODIGO, DESCRIPCION, ORDEN, APLICA_FORMULARIO) VALUES ('','$codigo','$descripcion',$orden,$aplica_formulario)
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[INF_CO_FASE_EP] Consulta exitosa, DATOS INGRESADOS:$codigo,$descripcion,$orden");
        } catch (Exception $ex) {
            $error = "[INF_CO_FASE_EP] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeUpdate(sfWebRequest $request)
  {
    $this->logMessage("[INF_CO_FASE_EP_PRUEBA_OBJ] Entra por editar objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id=$request['id_fase_ep'];
            $codigo=$request['codigo'];
            $descripcion=$request['descripcion'];
            $orden=$request['orden'];
            $aplica_formulario=$request['aplica_formulario'];
            if($aplica_formulario=="true"){
                $aplica_formulario=1;
            }
            else{
                $aplica_formulario=0;
            }
            $sql = <<<EOD
UPDATE CO_FASE_EP SET CODIGO='$codigo', DESCRIPCION='$descripcion', ORDEN=$orden, APLICA_FORMULARIO=$aplica_formulario WHERE ID_FASE_EP=$id
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[INF_CO_FASE_EP] Consulta exitosa, DATOS ACTUALIZADOS:$codigo,$descripcion,$orden");
        } catch (Exception $ex) {
            $error = "[INF_CO_FASE_EP] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeRemove(sfWebRequest $request)
  {
    $this->logMessage("[INF_CO_FASE_EP] Entra por eliminar objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id=$request['id_fase_ep'];
            $sql = <<<EOD
DELETE FROM CO_FASE_EP WHERE ID_FASE_EP=$id
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[INF_CO_FASE_EP] Consulta exitosa, DATO ELIMINADO:$id");
        } catch (Exception $ex) {
            $error = "[INF_CO_FASE_EP] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
}